﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Devices;
using Microsoft.Phone.BackgroundAudio;
using System.Windows.Navigation;
using System.Windows.Media.Imaging;
using System.IO.IsolatedStorage;

namespace PhoneApp1
{
    public partial class MainPage : PhoneApplicationPage
    {
        // 构造函数
        public MainPage()
        {
            InitializeComponent();
            BackgroundAudioPlayer.Instance.PlayStateChanged += new EventHandler(Instance_PlayStateChanged);
        }

        //刚加载时确定播放状态
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            if (PlayState.Playing == BackgroundAudioPlayer.Instance.PlayerState)
            {
                button1.Content = "■";
                textblock1.Text = "曲目：" + BackgroundAudioPlayer.Instance.Track.Title
                    + " 艺术家：" + BackgroundAudioPlayer.Instance.Track.Artist
                    + " 专辑：" + BackgroundAudioPlayer.Instance.Track.Album
                    + " 曲目长度：" +BackgroundAudioPlayer.Instance.Track.Duration.Minutes + ":" + BackgroundAudioPlayer.Instance.Track.Duration.Seconds;

                    using (IsolatedStorageFile storage = IsolatedStorageFile.GetUserStoreForApplication())
                    {
                        var stream = storage.OpenFile(BackgroundAudioPlayer.Instance.Track.AlbumArt.OriginalString, System.IO.FileMode.Open);
                        var bitmapImage = new BitmapImage();
                        bitmapImage.SetSource(stream);
                        imge1.Source = bitmapImage;
                        stream.Close();
                    }
            }
            else
            {
                button1.Content = "▶";
                textblock1.Text = "未播放曲目";
            }
        }

        void Instance_PlayStateChanged(object sender, EventArgs e)
        {
            switch (BackgroundAudioPlayer.Instance.PlayerState)
            {
                case PlayState.Playing:
                    button1.Content = "■";
                    button2.IsEnabled = true;
                    button3.IsEnabled = true;
                    break;

                case PlayState.Paused:
                case PlayState.Stopped:
                    button1.Content = "▶";
                    break;
            }

            if (null != BackgroundAudioPlayer.Instance.Track && BackgroundAudioPlayer.Instance.PlayerState!= PlayState.Stopped)
            {
                textblock1.Text = "曲目：" + BackgroundAudioPlayer.Instance.Track.Title
                    + " 艺术家：" + BackgroundAudioPlayer.Instance.Track.Artist
                    + " 专辑：" + BackgroundAudioPlayer.Instance.Track.Album
                    + " 曲目长度：" + BackgroundAudioPlayer.Instance.Track.Duration.Minutes + ":" + BackgroundAudioPlayer.Instance.Track.Duration.Seconds;

                    using (IsolatedStorageFile storage = IsolatedStorageFile.GetUserStoreForApplication())
                    {
                        var stream = storage.OpenFile(BackgroundAudioPlayer.Instance.Track.AlbumArt.OriginalString, System.IO.FileMode.Open);
                        var bitmapImage = new BitmapImage();
                        bitmapImage.SetSource(stream);
                        imge1.Source = bitmapImage;
                        stream.Close();
                    }
            }
        }


        //播放/暂停
        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            if (PlayState.Playing == BackgroundAudioPlayer.Instance.PlayerState)
                BackgroundAudioPlayer.Instance.Pause();
            else
                BackgroundAudioPlayer.Instance.Play();
        }

        //向前
        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            BackgroundAudioPlayer.Instance.SkipPrevious();
            button2.IsEnabled = false;
        }
        //向后
        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            BackgroundAudioPlayer.Instance.SkipNext();
            button3.IsEnabled = false;
        }
    }
}